Skip to content

API Endpoint Reference (1.0)

Tenovos offers a REST API for partner and customer integrations. This API provides a RESTful endpoint, token-based authorization, HTTP methods for operations, and JSON-formatted payloads. Use this API to incorporate Tenovos functionality into your own application.

This API is up-versioned when a breaking change is introduced such as

  • a change in the format of the response data for one or more calls
  • a change in the request or response type (i.e. changing an integer to a float)
  • removing any part of the API.

This API is not up-versioned for non-breaking changes such as

  • new endpoints
  • new response parameters
  • new optional request parameters
Download OpenAPI description
Languages
Servers
https://enterprise.services.tenovos.io/content-store-v1
https://enterprise-2.services.tenovos.io/content-store-v1
https://enterprise3.services.tenovos.io/content-store-v1
https://enterprise-4.services.tenovos.io/content-store-v1

Action Operations

Invoke the Action API to retrieve information about invoked Actions.

Operations

Asset Operations

Invoke the Asset API to create, retrieve, manipulate, and share Assets. This API also provides operations to manage Asset relationships and download Asset content.

Operations

Authentication Operations

Invoke the Authentication API to generate, refresh, and revoke access tokens. An access token is required to perform any authorized API operation.

Operations

Collection Operations

Invoke the Collection API to create, retrieve, edit, and delete Collections. Collections are used to group and catalog related Assets for quick access and consumption. Collections can be configured as:

  • private: Visible only to the user who created the Collection.
  • secured: Visible to shared users with permission.

When retrieving the Assets within a Collection, the requesting user will only see the Assets that the user has access to view. For example, a librarian may see all Assets within a Collection, but a general consumer user may only see a portion of those Assets, due to limited security access.

Operations

Create a Collection.

Request

Create a collection and add assets to it. Assets in the collection are identified by FileID therefore collectionDocument contains File ID

The user should have View permission on assets to be added to the collection.

Security
ApiKeyAuth or BasicAuth
Headers
X-API-Keystringrequired

Customer-specific API key required to invoke API.

Authorizationstringrequired

Provided by Authentication Token creation operation

AccessTokenstringrequired

JWT token provided by Authentication Token creation operation.

Content-Typestringrequired
Value"application/json"
Bodyapplication/jsonrequired

The Request Body must be a JSON object.

collectionTypestring
Enum"secured""private"
namestring

Name of the collection

Example: "Best of the month"
collectionDocumentArray of strings(uuid)

List of Asset IDs to be added to the Collection.

metadataTemplateIdstring(uuid)

Unique ID of the metadata template for 'secure' or 'private' collections

Example: "ea6eb24d-adef-4380-bd02-f64f567c437f"
securityTemplateIdsArray of strings(uuid)

List of Security Template IDs

Example: ["7d6f4e30-f423-11e9-8071-89c0c4052156"]
MetadataDocumentArray of MetadataStringValue (object) or MetadataRestrictedVocabularyValue (object) or MetadataDateValue (object) or MetadataMultiValue (object) or MetadataGridValue (object)

Array of metadata attributes that are required for the metadata template

curl -i -X POST \
  https://enterprise.services.tenovos.io/content-store-v1/collection \
  -H 'AccessToken: string' \
  -H 'Authorization: string' \
  -H 'Content-Type: application/json' \
  -H 'X-API-Key: YOUR_API_KEY_HERE' \
  -d '{
    "collectionType": "secured",
    "name": "Best of the month",
    "collectionDocument": [
      "497f6eca-6276-4993-bfeb-53cbbbba6f08"
    ],
    "metadataTemplateId": "ea6eb24d-adef-4380-bd02-f64f567c437f",
    "securityTemplateIds": [
      "7d6f4e30-f423-11e9-8071-89c0c4052156"
    ],
    "MetadataDocument": [
      {
        "metadataDefinitionId": "dfeb57c1-b149-4b15-920f-3f40ff0b959a",
        "metadataDefinitionValue": "Photo"
      }
    ]
  }'

Responses

Successful operation

Bodyapplication/json
statusCodestring
Enum"success""error"
Example: "success"
messagestring

detailed message

Example: "Collection successfully created"
collectionIdstring(uuid)

ID of created collection if successful

Example: "4b5896b4-33e4-41ac-b251-39a4dbaa25b1"
Response
application/json
{ "statusCode": "success", "message": "Collection successfully created", "collectionId": "4b5896b4-33e4-41ac-b251-39a4dbaa25b1" }

Get a single Collection and assigned Assets.

Request

Retrieve a single Collection specified by Collection ID. The retrieved Collection may be either a secured Collection or a private Collection created by the User. The Collection will include the list of Assets assigned to the Collection, referenced by Asset File ID.

The User retrieving the Collection must have the Collection Security Role Privilege.

Security
ApiKeyAuth or BasicAuth
Path
idstringrequired

Specify Collection ID

Headers
X-API-Keystringrequired

Customer-specific API key required to invoke API.

Authorizationstringrequired

Provided by Authentication Token creation operation

AccessTokenstringrequired

JWT token provided by Authentication Token creation operation.

Content-Typestringrequired
Value"application/json"
curl -i -X GET \
  'https://enterprise.services.tenovos.io/content-store-v1/collection/{id}' \
  -H 'AccessToken: string' \
  -H 'Authorization: string' \
  -H 'Content-Type: application/json' \
  -H 'X-API-Key: YOUR_API_KEY_HERE'

Responses

The Response Body is a JSON object describing the collection.

Bodyapplication/json
expirationDateinteger

Expiration date in milliseconds

Example: 1613755131855
lastUpdatedEpochinteger

Last update time in milliseconds

Example: 1613755131855
shareMessagestring
Example: ""
recipientsArray of strings
downloadIdstring
Example: "NULL"
sharedstring

Shared Collection Flag (Y | N)

Enum"N""Y"
namestring

Collection Name

Example: "Best of the month"
shareDocumentArray of strings(uuid)

Array of Asset IDs for shared Collection

senderobject
createdEpochinteger

Creation time in milliseconds

Example: 1613755131855
userCognitoIdstring(uuid)

User ID who created this Collection

Example: "7d675ef0-f423-11e9-8071-89c0c4052141"
collectionTypestring

Type of Collection (secured | private)

Enum"secured""private"
collectionIdstring(uuid)

Collection ID

Example: "4dc328ce-4b3f-4f76-b7bb-1e83ad35458a"
collectionDocumentArray of strings(uuid)

Array of Asset File IDs in Collection

Example: ["0176c8e6-1017-4308-be3b-2de3931cbb37"]
customerIdstring

Customer ID

Example: "1235644566523"
Response
application/json
{ "expirationDate": 1613755131855, "lastUpdatedEpoch": 1613755131855, "shareMessage": "", "recipients": [ "string" ], "downloadId": "NULL", "shared": "N", "name": "Best of the month", "shareDocument": [ "497f6eca-6276-4993-bfeb-53cbbbba6f08" ], "sender": {}, "createdEpoch": 1613755131855, "userCognitoId": "7d675ef0-f423-11e9-8071-89c0c4052141", "collectionType": "secured", "collectionId": "4dc328ce-4b3f-4f76-b7bb-1e83ad35458a", "collectionDocument": [ "0176c8e6-1017-4308-be3b-2de3931cbb37" ], "customerId": "1235644566523" }

Delete a Collection.

Request

User can delete the collection, but the Assets assigned to the Collection will remain and dissociate from this Collection.

The User submitting the request to delete a private Collection must have the Collection and Delete Security Role Privilege. Secured Collections may only be deleted by Users with the Purge Security Role Privilege.

Security
ApiKeyAuth or BasicAuth
Path
idstringrequired

Specify Collection ID

Headers
X-API-Keystringrequired

Customer-specific API key required to invoke API.

Authorizationstringrequired

Provided by Authentication Token creation operation

AccessTokenstringrequired

JWT token provided by Authentication Token creation operation.

Content-Typestringrequired
Value"application/json"
curl -i -X DELETE \
  'https://enterprise.services.tenovos.io/content-store-v1/collection/{id}' \
  -H 'AccessToken: string' \
  -H 'Authorization: string' \
  -H 'Content-Type: application/json' \
  -H 'X-API-Key: YOUR_API_KEY_HERE'

Responses

Successful operation

Bodyapplication/jsonArray [
statusstring
Example: "success"
messagestring
Example: "Collection delete operation succeeded"
]
Response
application/json
[ { "status": "success", "message": "Collection delete operation succeeded" } ]

Update a Collection.

Request

Update a Collection's attributes or assigned Assets. The list of existing assets is replaced with assets provided in the call. Assets in the collection are referenced by Asset FileID therefore the collectionDocument must contain asset's FileID.

The User editing the Collection must have the Collection Security Role Privilege. The User must have View access to the Assets that are being added to or removed from the Collection.

Security
ApiKeyAuth or BasicAuth
Path
idstringrequired

Specify Collection ID

Headers
X-API-Keystringrequired

Customer-specific API key required to invoke API.

Authorizationstringrequired

Provided by Authentication Token creation operation

AccessTokenstringrequired

JWT token provided by Authentication Token creation operation.

Content-Typestringrequired
Value"application/json"
Bodyapplication/jsonrequired

The Request Body must be a JSON object.

collectionTypestring

Type of the collection.

Enum"secured""private"
namestring

Name of the collection

Example: "Photo Collection"
collectionDocumentArray of strings(uuid)

List of fileIDs to be added to collection. This list will replace the current set of assets in the collection.

curl -i -X PATCH \
  'https://enterprise.services.tenovos.io/content-store-v1/collection/{id}' \
  -H 'AccessToken: string' \
  -H 'Authorization: string' \
  -H 'Content-Type: application/json' \
  -H 'X-API-Key: YOUR_API_KEY_HERE' \
  -d '{
    "collectionType": "secured",
    "name": "Photo Collection",
    "collectionDocument": [
      "497f6eca-6276-4993-bfeb-53cbbbba6f08"
    ]
  }'

Responses

Successful operation

Bodyapplication/jsonArray [
messagestring
]
Response
application/json
{ "message": "Collection update was successful" }

Share all accessible Assets in a Collection.

Request

Share the zip file of all accessible Assets in a collection and send to the specified emails in share users list. User can also send the custom share message along with request.

The user sharing the Assets must be granted the Download and Share Security Template permission on the Assets being shared.

Security
ApiKeyAuth or BasicAuth
Path
idstringrequired

Specify Collection ID

Headers
X-API-Keystringrequired

Customer-specific API key required to invoke API.

Authorizationstringrequired

Provided by Authentication Token creation operation

AccessTokenstringrequired

JWT token provided by Authentication Token creation operation.

Content-Typestringrequired
Value"application/json"
Bodyapplication/jsonrequired

The Request Body must be a JSON object.

senderobject(Sender)
shareUsersArray of objects(Recipient)

A list of email addresses of the recipients.

shareMessagestring

A message from sender to recipient

Example: "A message from sender to recipient"
curl -i -X POST \
  'https://enterprise.services.tenovos.io/content-store-v1/collection/{id}/share' \
  -H 'AccessToken: string' \
  -H 'Authorization: string' \
  -H 'Content-Type: application/json' \
  -H 'X-API-Key: YOUR_API_KEY_HERE' \
  -d '{
    "sender": {
      "name": "Michael Lee"
    },
    "shareUsers": [
      {
        "email": "john@mail.com",
        "name": "John"
      }
    ],
    "shareMessage": "A message from sender to recipient"
  }'

Responses

Successful operation

Bodyapplication/json
StatusCodeinteger
Example: 200
ExecutedVersionstring
Example: "$LATEST"
Payloadstring
Example: "{\"statusCode\":200,\"body\":\"{\\\"message\\\":\\\"Message sent successfully\\\"}\",\"headers\":{\"content-type\":\"application/json\"}}"
Response
application/json
{ "StatusCode": 200, "ExecutedVersion": "$LATEST", "Payload": "{\"statusCode\":200,\"body\":\"{\\\"message\\\":\\\"Message sent successfully\\\"}\",\"headers\":{\"content-type\":\"application/json\"}}" }

Customer Operations

Invoke the Customer API to retrieve Customer account profile information.

Operations

Metadata Operations

Invoke the Metadata API to retrieve Metadata Template to be applied to Assets during Asset creation. A Metadata Template defines a set of Metadata Attributes of varying types, including Text, Date, Controlled Vocabulary, Tabular, and Cascading Attributes. When a Metadata Template is assigned to a new Asset, the corresponding Metadata Attributes will be available for population on the Asset.

Operations

Search Operations

Search for Collections by Collection name.

Perform Asset searches using keywords or Attribute-specific search terms using the Keyword Search endpoint.

Perform a scan on all assets based on search criteria using a cursor to page through the entire result set of assets.

Operations

Security Operations

Invoke the Metadata API to retrieve Security Template information to be applied to Assets during Asset creation or edit.

Operations

User Operations

Invoke the User API to retrieve User profile information.

Operations

Proof Operations

Operations

Cart Operations

Operations